package accrue.analysis.goals;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.frontend.Scheduler;
import polyglot.frontend.goals.Goal;
import polyglot.frontend.goals.VisitorGoal;
import polyglot.types.TypeSystem;
import accrue.AccrueScheduler;
import accrue.analysis.visit.MakeInstanceInitializersExplicit;

public class MakeInstanceInitializersExplicitGoal extends VisitorGoal {
    public static Goal create(Scheduler scheduler, Job job, TypeSystem ts,
            NodeFactory nf) {
        return scheduler.internGoal(new MakeInstanceInitializersExplicitGoal(job,
                                                                             ts,
                                                                             nf));
    }

    protected MakeInstanceInitializersExplicitGoal(Job job, TypeSystem ts,
            NodeFactory nf) {
        super(job, new MakeInstanceInitializersExplicit(job, ts, nf));
    }

    @Override
    public Collection<Goal> prerequisiteGoals(Scheduler scheduler) {
        List<Goal> l = new ArrayList<Goal>();
        l.add(((AccrueScheduler) scheduler).helper().PreModificationBarrier());
        l.add(((AccrueScheduler) scheduler).helper().MoveLocalClassesGoal(job));

        l.addAll(super.prerequisiteGoals(scheduler));
        return l;
    }
}
